﻿using Calculator;
using System;
using System.IO;
using System.Threading;

namespace ChromaController
{
    internal class Program
    {
        private static void Main(string[] args)
        {
            ColoreOutput coloreOutput = new ColoreOutput(ChromaFX());
            Thread coloreThread = new Thread(coloreOutput.Start);
            coloreThread.Start();
            KeyConverter keyConverter = new KeyConverter();
            Calc calculator = new Calc();
            MonitorManager monitorManager = new MonitorManager(coloreOutput, keyConverter, calculator);
            coloreThread.Join();
        }

        private static string ChromaFX()
        {
            string path = Environment.ExpandEnvironmentVariables(@"%APPDATA%\KeyboardCalculator\");
            string filename = "ChromaEffects.xml";
            if (!File.Exists(path + filename))
                throw new ApplicationException("No ChromaEffect.xml found in %APPDATA%\\KeyboardCalculator\\");
            return path + filename;
        }
    }
}